//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

/*
	*******************************************************************
	All examples in this support document are only intended
	to improve understanding of the functionality and 
	handling of the equipment. 
	Beijer Electronics AB cannot assume any liability if these
	examples are used in real applications.
	In view of the wide range of applications for this 
	equipment, users must acquire sufficient knowledge 
	themselves in order to ensure that it is correctly used in 
	their specific application. Persons responsible for the 
	application and the equipment must themselves 
	ensure that each application is in compliance with all 
	relevant requirements, standards and legislation in 
	respect to configuration and safety.
	Beijer Electronics AB will accept no liability for any 
	damage incurred during the installation or use of this 
	equipment.
	Beijer Electronics AB prohibits all modification, changes
	or conversion of the equipment.
	*******************************************************************
	*/

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
    
	using System.Text;
	using Microsoft.Win32;
	using System.Runtime.InteropServices;

    public partial class NetControl
    {
		private const int iXPanel_TK = 0;
		private const int iXPanel_TA = 1;
		private const int iXPanel_TxB = 1;		
		private const int iXPanel_TxA = 2;
		
		public const String NDIS_DEVICE_NAME = "NDS0:";
		public const uint IOCTL_NDIS_BIND_ADAPTER = 0x00170032;
		public const uint IOCTL_NDIS_REBIND_ADAPTER = 0x0017002e;
		public const uint IOCTL_NDIS_UNBIND_ADAPTER = 0x00170036;

		[Flags]
		public enum CREATEFILE
		{
			METHOD_BUFFERED = 0,
			FILE_WRITE_ACCESS = 0x0002,
			FILE_DEVICE_VIDEO = 0x00000023,
			FILE_ANY_ACCESS = 0,

			GENERIC_READ = -2147483648,
			GENERIC_WRITE = 0x40000000,
			OPEN_EXISTING = 3,
			INVALID_HANDLE_VALUE = -1,
			FILE_SHARE_READ = 0x1,
			FILE_SHARE_WRITE = 0x2
		}

		[DllImport("coredll", SetLastError = true)]
		private static extern IntPtr CreateFile(String lpFileName, int dwDesiredAccess, int dwShareMode, IntPtr lpSecurityAttributes, int dwCreationDisposition, UInt32 dwFlagsAndAttributes, IntPtr hTemplateFile);

		[DllImport("coredll.dll", SetLastError = true)]
		private static extern bool DeviceIoControl(IntPtr hDevice, uint dwIoControlCode, byte[] lpInBuffer,
		int nInBufferSize, byte[] lpOutBuffer, int nOutBufferSize, ref int lpBytesReturned, IntPtr lpOverlapped);

		[DllImport("coredll", SetLastError = true)]
		private static extern bool CloseHandle(IntPtr hObject);

		[DllImport("iphlpapi.dll", EntryPoint = "GetAdaptersInfo", SetLastError = true)]
		private static extern int GetAdaptersInfo(IntPtr pAdapterInfo, ref int pOutBufLen);

		public static string GetAdapterName(int PanelType, int PortNo)
		{
			if(PanelType == iXPanel_TK)			// T/K type panels (legacy product)
			{
				if(PortNo == 1)			
				{
					IP_ADAPTER_INFO adapterInfo = null;
					if (GetMyAdaptersInfo(0, out adapterInfo) && (adapterInfo != null))
					{
						return adapterInfo.AdapterName;	
					}
				}
			}
			if(PanelType == iXPanel_TA)		// TA / TxB type panels
			{
				if(PortNo == 1)				// Port 1 (marked LAN B) 
				{
					return ("PCI\\RTCENIC1");
				}
				if(PortNo == 2)				// Port 2 (marked LAN A)
				{
					return ("SMSC95001");
				}
			}
			
			if(PanelType == iXPanel_TxA)	// TxA type panels
			{
				if(PortNo == 1)			
				{
					return("EMACB1");
				}				
			}	
			return string.Empty;
		}
		

		public static bool AdapterGetReg(string AdapterName, ref string Addr, ref string SubnetMask, ref string Gateway, ref string DNS1, ref string DNS2, ref bool bDHCP)
		{
			string regPath = @"\Comm\" + AdapterName + @"\Parms\TcpIp";
			Microsoft.Win32.RegistryKey key = Registry.LocalMachine.OpenSubKey(regPath, false);
			if (key != null)
			{
				object obj;

				bDHCP = true;

				obj = key.GetValue("EnableDHCP");
				if (obj != null && obj.GetType() == typeof(Int32))
				{
					Int32 value = Convert.ToInt32(obj);
					bDHCP = value != 0 ? true : false;

					if (bDHCP)
						obj = key.GetValue("DhcpIPAddress");
					else
						obj = key.GetValue("IPAddress");
					if (obj != null && obj.GetType() == typeof(string))
					{
						Addr = obj as string;
					}
					else if (obj != null && obj.GetType() == typeof(string[]))
					{
						string[] str = obj as string[];
						if (str.Length >= 1)
							Addr = str[0];
					}

					if (bDHCP)
						obj = key.GetValue("DhcpSubnetMask");
					else
						obj = key.GetValue("SubnetMask");
					if (obj != null && obj.GetType() == typeof(string))
					{
						SubnetMask = obj as string;
					}
					else if (obj != null && obj.GetType() == typeof(string[]))
					{
						string[] str = obj as string[];
						if (str.Length >= 1)
							SubnetMask = str[0];
					}

					if (bDHCP)
						obj = key.GetValue("DhcpDefaultGateway");
					else
						obj = key.GetValue("DefaultGateway");
					if (obj != null && obj.GetType() == typeof(string))
					{
						Gateway = obj as string;
					}
					else if (obj != null && obj.GetType() == typeof(string[]))
					{
						string[] str = obj as string[];
						if (str.Length >= 1)
							Gateway = str[0];
					}

					if (bDHCP)
						obj = key.GetValue("DhcpDNS");
					else
						obj = key.GetValue("DNS");
					if (obj != null && obj.GetType() == typeof(string))
					{
						DNS1 = obj as string;
					}
					else if (obj != null && obj.GetType() == typeof(string[]))
					{
						string[] str = obj as string[];
						if (str.Length >= 1)
							DNS1 = str[0];
						if (str.Length >= 2)
							DNS2 = str[1];
					}
				}
			}
			return true;
		}

		public static bool AdapterSetReg(string AdapterName, string Addr, string SubnetMask, string Gateway, string DNS1, string DNS2, bool bDHCP)
		{
			bool fResult = false;

			string regPath = @"\Comm\" + AdapterName + @"\Parms\TcpIp";
			Microsoft.Win32.RegistryKey key = Registry.LocalMachine.OpenSubKey(regPath, true);
			if (key != null)
			{
				Int32 value = bDHCP ? 1 : 0;
				key.SetValue(@"EnableDHCP", value);

				if(!bDHCP)
				{	
					key.SetValue(@"IPAddress", new string[] { Addr }, RegistryValueKind.MultiString);
					key.SetValue(@"SubnetMask", new string[] { SubnetMask}, RegistryValueKind.MultiString);
					key.SetValue(@"DefaultGateway", new string[] { Gateway}, RegistryValueKind.MultiString);
					key.SetValue(@"DNS", new string[] { DNS1, DNS2}, RegistryValueKind.MultiString);
				}

				return RebindAdapter(AdapterName);
			}

			return fResult;
		}

		public static bool RebindAdapter(string AdapterName)
		{
			IntPtr ndisAccess = CreateFile(
				NDIS_DEVICE_NAME,
				(int)(CREATEFILE.GENERIC_READ | CREATEFILE.GENERIC_WRITE),
				(int)(CREATEFILE.FILE_SHARE_READ | CREATEFILE.FILE_SHARE_WRITE),
				IntPtr.Zero,
				(int)(CREATEFILE.OPEN_EXISTING),
				0,
				IntPtr.Zero
				);

			if ((int)ndisAccess != (int)(CREATEFILE.INVALID_HANDLE_VALUE))
			{
				int xcount = 0;
				byte[] namebytes = new byte[(AdapterName.Length + 1) * 2];

				Encoding.Unicode.GetBytes(AdapterName, 0, AdapterName.Length, namebytes, 0);

				if (!DeviceIoControl(ndisAccess, IOCTL_NDIS_REBIND_ADAPTER,
					namebytes, namebytes.Length, null, 0, ref xcount, IntPtr.Zero))
				{
					CloseHandle(ndisAccess);

					return false;
				}

				CloseHandle(ndisAccess);

				return true;
			}
			MessageBox.Show("CreateFile Failed");

			return false;
		}

		#region GetAdaptersInfo

		private static bool GetMyAdaptersInfo(int adapterIndex, out IP_ADAPTER_INFO info)
		{
			uint dwLowestIndex = 0xFF, dwHighestIndex = 0; 
			info = null;
			IntPtr pAdapterInfo = IntPtr.Zero;
			IntPtr pAdapterInfoOrg;

			try
			{
				int outBufLen = 0;
				int ret = GetAdaptersInfo(pAdapterInfo, ref outBufLen);
				pAdapterInfo = CustomMarshal.AllocHLocal((uint)outBufLen);

				ret = GetAdaptersInfo(pAdapterInfo, ref outBufLen);
				int currIndex = 0;
				pAdapterInfoOrg = pAdapterInfo;		
				//IN WinCE the order of adapters returned by GetAdaptersInfo is not specified

				//Find all adapters and save index numbers
				while (pAdapterInfo != IntPtr.Zero) //&& currIndex <= adapterIndex)
				{
					if (ret != 0)
					{
						info = null;
						return false;
					}
					else
					{
						if (pAdapterInfo != IntPtr.Zero)
						{
							info = new IP_ADAPTER_INFO(pAdapterInfo);
							if (info.Index > dwHighestIndex)
							{
								dwHighestIndex = info.Index;
							}
							if (info.Index < dwLowestIndex)
							{
								dwLowestIndex = info.Index;
							}
						}
						else
						{
							info = null;
						}
						pAdapterInfo = info.Next;
						currIndex++;
					}
				}
				//Now find actual adapter
				uint requestedIndex;
				if (adapterIndex == 0)
				{
					requestedIndex = dwLowestIndex;
				}
				else
				{
					requestedIndex = dwHighestIndex;
				}
				pAdapterInfo = pAdapterInfoOrg;
				while (pAdapterInfo != IntPtr.Zero)
				{
					if (ret != 0)
					{
						info = null;
						return false;
					}
					else
					{
						if (pAdapterInfo != IntPtr.Zero)
						{
							info = new IP_ADAPTER_INFO(pAdapterInfo);
							if (info.Index == requestedIndex)
							{
								break;
							}
						}
						else
						{
							info = null;
						}
						pAdapterInfo = info.Next;
						currIndex++;
					}
				}
			}
			finally
			{
				CustomMarshal.FreeHLocal(pAdapterInfo);
			}

			return true;
		}

		public static bool GetAdaptersInfo(ref string ipAddress, ref string subnetMask, ref string gateway, ref bool dhcp)
		{
			IP_ADAPTER_INFO adapterInfo = null;

			if (GetMyAdaptersInfo(0,out adapterInfo) && (adapterInfo != null))
			{
				ipAddress = adapterInfo.CurrentIpAddress.IpAddress.String;
				subnetMask = adapterInfo.CurrentIpAddress.IpMask.String;
				gateway = adapterInfo.GatewayList.IpAddress.String;
				dhcp = adapterInfo.DhcpEnabled != 0;

				return true;
			}

			return false;
		}

		#endregion

		#region IPHelper Structures

		internal class IP_ADAPTER_INFO
		{
			public IntPtr Next;
			public uint ComboIndex;
			public string AdapterName;
			public string Description;
			public uint AddressLength;
			public byte[] Address;
			public uint Index;
			public uint Type;
			public uint DhcpEnabled;
			public IP_ADDR_STRING CurrentIpAddress;
			public IP_ADDR_STRING IpAddressList;
			public IP_ADDR_STRING GatewayList;
			public IP_ADDR_STRING DhcpServer;
			public uint HaveWins;
			public IP_ADDR_STRING PrimaryWinsServer;
			public IP_ADDR_STRING SecondaryWinsServer;
			public DateTime LeaseObtained;
			public DateTime LeaseExpires;

			public IP_ADAPTER_INFO(IntPtr baseAddress)
			{
				this.Next = CustomMarshal.GetIntPtr(baseAddress, 0);
				this.ComboIndex = CustomMarshal.GetUInt32(baseAddress, 4);
				this.AdapterName = CustomMarshal.PtrToStringAscii(baseAddress, 8, 256);
				this.Description = CustomMarshal.PtrToStringAscii(baseAddress, 268, 128);
				this.AddressLength = CustomMarshal.GetUInt32(baseAddress, 400);
				this.Address = CustomMarshal.GetByteArray(baseAddress, 404, 8);
				this.Index = CustomMarshal.GetUInt32(baseAddress, 412);
				this.Type = CustomMarshal.GetUInt32(baseAddress, 416);
				this.DhcpEnabled = CustomMarshal.GetUInt32(baseAddress, 420);
				this.CurrentIpAddress = new IP_ADDR_STRING(CustomMarshal.GetIntPtr(baseAddress, 424));
				this.IpAddressList = new IP_ADDR_STRING(new IntPtr((int)baseAddress + 428));
				this.GatewayList = new IP_ADDR_STRING(new IntPtr((int)baseAddress + 468));
				this.DhcpServer = new IP_ADDR_STRING(new IntPtr((int)baseAddress + 508));
				this.HaveWins = CustomMarshal.GetUInt32(baseAddress, 548);
				this.PrimaryWinsServer = new IP_ADDR_STRING(new IntPtr((int)baseAddress + 552));
				this.SecondaryWinsServer = new IP_ADDR_STRING(new IntPtr((int)baseAddress + 592));
				this.LeaseObtained = CustomMarshal.Time_tToDateTime(CustomMarshal.GetUInt32(baseAddress, 632));
				this.LeaseExpires = CustomMarshal.Time_tToDateTime(CustomMarshal.GetUInt32(baseAddress, 636));
			}
		}

		internal class IP_ADDR_STRING
		{
			public IntPtr Next;
			public IP_ADDRESS_STRING IpAddress;
			public IP_ADDRESS_STRING IpMask;
			public int Context;

			public IP_ADDR_STRING(IntPtr baseAddress)
			{
				this.Next = CustomMarshal.GetIntPtr(baseAddress, 0);
				this.IpAddress = new IP_ADDRESS_STRING(baseAddress, 4);
				this.IpMask = new IP_ADDRESS_STRING(baseAddress, 20);
				this.Context = CustomMarshal.GetInt32(baseAddress, 36);
			}
		}

		internal class IP_ADDRESS_STRING
		{
			public string String;

			public IP_ADDRESS_STRING(IntPtr baseAddress, int offset)
			{
				this.String = CustomMarshal.PtrToStringAscii(baseAddress, offset, 16);
			}
		}

		#endregion
    }
}
