//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

/*
	*******************************************************************
	All examples in this support document are only intended
	to improve understanding of the functionality and 
	handling of the equipment. 
	Beijer Electronics AB cannot assume any liability if these
	examples are used in real applications.
	In view of the wide range of applications for this 
	equipment, users must acquire sufficient knowledge 
	themselves in order to ensure that it is correctly used in 
	their specific application. Persons responsible for the 
	application and the equipment must themselves 
	ensure that each application is in compliance with all 
	relevant requirements, standards and legislation in 
	respect to configuration and safety.
	Beijer Electronics AB will accept no liability for any 
	damage incurred during the installation or use of this 
	equipment.
	Beijer Electronics AB prohibits all modification, changes
	or conversion of the equipment.
	*******************************************************************
	*/

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;

	public partial class Start
    {
	
		void btnChangeIP_Click(System.Object sender, System.EventArgs e)
		{
			string addr = string.Empty;
			string snet = string.Empty;									
			string gatw = string.Empty;			
			string dns1 = string.Empty;			
			string dns2 = string.Empty;
			bool dhcp = false;
			
			TextBox1.Text = "";
					
			// Fetch information regarding the IP configuration of port 1
			if(!IPSettings.GetPort(2,1,ref addr,ref snet,ref gatw, ref dns1, ref dns2, ref dhcp))
			{			
				MessageBox.Show("Unable to fetch IP-configuration for port 1");
			}
			
			// Add information to the text box
			TextBox1.Text += ">Port 1<"+ Environment.NewLine;
			TextBox1.Text += addr + Environment.NewLine;
			TextBox1.Text += snet + Environment.NewLine;
			TextBox1.Text += gatw + Environment.NewLine;
			TextBox1.Text += dns1 + Environment.NewLine;
			TextBox1.Text += dns2 + Environment.NewLine;
			TextBox1.Text += dhcp.ToString() + Environment.NewLine;
			TextBox1.Text += "------------------" + Environment.NewLine;
						
			// Change the IP configuration of port 1
			if(!IPSettings.SetPort(2,1,"10.0.0.27","255.0.0.0","10.0.0.1","8.8.8.8","8.8.4.4",false))
			{
				MessageBox.Show("Unable to set IP-configuration for port 1");
			}
			
			// Fetch information regarding the IP configuration of port 1
			if(!IPSettings.GetPort(2,1,ref addr,ref snet,ref gatw, ref dns1, ref dns2, ref dhcp))
			{
				MessageBox.Show("Unable to fetch IP-configuration for port 1");
			}
			// Add information to the text box
			TextBox1.Text += addr + Environment.NewLine;
			TextBox1.Text += snet + Environment.NewLine;
			TextBox1.Text += gatw + Environment.NewLine;
			TextBox1.Text += dns1 + Environment.NewLine;
			TextBox1.Text += dns2 + Environment.NewLine;
			TextBox1.Text += dhcp.ToString() + Environment.NewLine;
			TextBox1.Text += "------------------" + Environment.NewLine;
		}
    }
}
